package sun.net.www.protocol.http;

import sun.util.logging.PlatformLogger;
import java.io.IOException;
import java.lang.reflect.Constructor;

public abstract class Negotiator
{
    public Negotiator() {
    }
    
    static Negotiator getNegotiator(HttpCallerInfo httpCallerInfo) {
        Constructor<Object> constructor;
        try {
            constructor = Class.forName("sun.net.www.protocol.http.spnego.NegotiatorImpl", true, null).getConstructor(new Class[] { HttpCallerInfo.class });
        }
        catch (ClassNotFoundException ex) {
            finest(ex);
            return null;
        }
        catch (ReflectiveOperationException detailMessage) {
            throw new AssertionError(detailMessage);
        }
        try {
            return (Negotiator)(Negotiator)constructor.newInstance(new Object[] { httpCallerInfo });
        }
        catch (ReflectiveOperationException ex2) {
            finest(ex2);
            Throwable cause = ex2.getCause();
            if (cause != null && cause instanceof Exception) {
                finest((Exception)cause);
            }
            return null;
        }
    }
    
    public abstract byte[] firstToken() throws IOException;
    
    public abstract byte[] nextToken(byte[] p0) throws IOException;
    
    private static void finest(Exception obj) {
        PlatformLogger httpLogger = HttpURLConnection.getHttpLogger();
        if (httpLogger.isLoggable(PlatformLogger.Level.FINEST)) {
            httpLogger.finest("NegotiateAuthentication: " + obj);
        }
    }
}
